//importing necessary functions from d3
import { select, json, geoPath, geoEquirectangular } from 'd3';
//importing feature method from topojson
import { feature } from 'topojson';

//giving svg method
const svg = select('svg');

//choosing necessary functions for viewing the worldmap
const projection = geoEquirectangular();
const pathGenerator = geoPath().projection(projection);

//defining the class named as sphere
svg.append('path')
    .attr('class', 'sphere')
    .attr('d', pathGenerator({type: 'Sphere'}));

//giving json file which is needed for visualizing the world map
json('https://cdn.jsdelivr.net/npm/world-atlas@2/countries-110m.json')
  .then(data => {
    const countries = feature(data, data.objects.countries);
//giving selectall function, this is used for opting all the countries
    svg.selectAll('path').data(countries.features)
      .enter().append('path')
        .attr('class', 'country')
        .attr('d', pathGenerator);
  });